<script lang="ts" setup>
interface Table {
  headers: string[];
  rows: {
    columns: string[];
  }[];
}

defineProps<{
  title?: string;
  text?: string;
  table: Table;
  footer?: string;
  config?: {
    ariaLabel?: string;
    addBottomMargin?: boolean;
  };
}>();
</script>

<template>
  <SlpContainer>
    <SlpRow>
      <SlpColumn>
        <SlpTypography v-if="title" tag="h4" variant="heading4">{{ title }} </SlpTypography>
        <SlpTypography v-if="text" tag="p" variant="body1" class="slp-pt-8">{{ text }} </SlpTypography>
        <table
          class="table full-width"
          :class="{ 'table--padding': config?.addBottomMargin }"
          :aria-describedby="config?.ariaLabel ?? title"
        >
          <thead>
            <tr>
              <th v-for="header in table.headers" :key="header" v-html="$md.render(header)" />
            </tr>
          </thead>
          <tbody>
            <tr v-for="(row, rowIndex) in table.rows" :key="rowIndex">
              <td v-for="column in row.columns" :key="column" v-html="$md.render(column)" />
            </tr>
          </tbody>
        </table>
        <div v-if="footer" class="footer" v-html="$md.render(footer)" />
      </SlpColumn>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
h2 {
  margin-bottom: 20px;
  font-size: 23px;
  font-weight: 600;
}

h4 {
  text-transform: uppercase;
}

p {
  font-size: $font-size-default;
}

.table {
  border: 1px solid #f2f2f2;
  box-sizing: border-box;
  border-radius: 4px;
  width: 100%;
  margin: $spacing-16 auto $spacing-32;

  &.full-width {
    width: 100%;
  }

  &--padding {
    margin-bottom: $spacing-96;
  }
}

table tr > td,
tr > th {
  width: 75% !important;
}

tr {
  td,
  th {
    width: 100%;
    text-align: left;
    padding: 10px 25px;
  }
}

thead {
  tr:first-child {
    th {
      background: #f8f8f8;
    }
  }
}

tbody {
  tr:nth-child(even) {
    td {
      background: #f8f8f8;
    }
  }

  tr {
    td:last-child {
      margin: 0;
    }
  }
}

:deep(.footer) {
  padding-bottom: $spacing-32;

  p {
    margin: $spacing-8 $spacing-0;
  }
}
</style>
